# izanagi

A run-and-gun shooter inspired by Metal Slug and Counter-Strike.

## Setup

The following tools are required:

* CMake
* Ninja
* Clang
* [Windows SDK](https://developer.microsoft.com/en-us/windows/downloads/windows-sdk/) (Windows)
* `autoconf` (macOS/*NIX)
* `make` (macOS/*NIX)
* `libtool` (*NIX)

For Windows and macOS, it is recommended to use Chocolatey and Homebrew respectively, for retrieving the required tools.

For *NIX, use whatever dependency manager you prefer to obtain the needed tools.

### Windows

1. Ensure your environment variables are set up.

   > **Important:** Set your `CC` environment variable to the full path of `clang-cl.exe`

   > **Important:** Set your `CMAKE_MT` environment variable to the full path of `mt.exe`, which can be found on your
   > Windows SDK installation folder (usually `C:/Program Files (x86)/Windows Kits/10/bin/10.0.19041.0/x86/mt.exe`)

2. Clone this repo recursively.
3. Build the dependencies under `subprojects`. Follow the instructions on building for Visual C.

   > **Important:** For `libwebsockets`, follow the [instructions on building LWS](https://libwebsockets.org/lws-api-doc-master/html/md_README_8build.html).

4. Generate the CMake cache.
5. Build the specific executables you want to build, which are defined in `CMakeLists.txt`.

### macOS/*NIX

1. Clone this repo recursively.
2. Build the dependencies under `subprojects`. Follow the instructions on building for *NIX (macOS should have similar
   instructions for *NIX).
3. Generate the CMake cache.
4. Build the specific executables you want to build, which are defined in `CMakeLists.txt`.
